package tsp.csc4509.tpnote;

import static tsp.csc4509.common.Log.COMM;
import static tsp.csc4509.common.Log.GEN;

import java.io.IOException;
import org.apache.logging.log4j.Level;

import tsp.csc4509.common.Log;

public final class AppliServer {

	/**
	 * position of the port number in argv[].
	 */
	private static final int PORTARG = 0;

	/**
	 * 
	 */
	private AppliServer() {

	}

	/**
	 * Classe d'application du serveur.
	 * 
	 * @param args args[0]: numéro du port.
	 * @throws NumberFormatException
	 * @throws IOException
	 * @throws InterruptedException
	 */
	public static void main(final String[] args) throws NumberFormatException, IOException, InterruptedException {
		if (args.length != 1) {
			System.err.println("usage: Server <port>");
			return;
		}
	//	Log.setLevel(GEN, Level.INFO);
	//	Log.setLevel(COMM, Level.INFO);

		Server server = new Server(Integer.parseInt(args[PORTARG]));
		server.service();

	}

}
