package tsp.csc4509.tpnote;

/**
 * Énumération des 4 types de message du protocole.
 * @author Éric Lallet.
 *
 */
public enum ProtocolMessageType {
	/**
	 * PUT: requête d'un client pour préparer l'émission d'un fichier.
	 */
	PUT("PUT"),
	/**
	 * GET: requête d'un client pour que le serveur lui envoie de tous les messages qui lui sont destinés.
	 */
	GET("GET"),
	/**
	 * SEND: requête du serveur pour signaler au client qu'il peut 
	 * se connecter pour envoyer le fichier de la requête PUT.
	 */
	SEND("SEND"),
	/**
	 * RECEIVE: requête du serveur pour signaler au client qu'il peut
	 * se connecter pour recevoir un fichier demander par la requête GET.
	 */
	RECEIVE("RECEIVE");

	/**
	 * Requête sous la forme d'une chaîne de caractère pour les affichages.
	 */
	private String name;

	/**
	 * Constructeur qui initialise l'attribut name.
	 * @param name valeur de l'attribut name.
	 */
	private ProtocolMessageType(final String name) {
		this.name = name;
	}

	@Override
	public String toString() {
		return name;
	}
}
