package tsp.csc4509.tpnote;

import static org.junit.jupiter.api.Assertions.assertNotNull;
import static org.junit.jupiter.api.Assertions.assertTrue;

import java.io.IOException;
import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.nio.ByteBuffer;
import java.nio.channels.ServerSocketChannel;
import java.nio.channels.SocketChannel;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.FutureTask;

import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.io.TempDir;

public class TestCreateServerSocketChannel {
	
	@Test
	public void testCreateServerSocketChannel() throws IOException, InterruptedException, ExecutionException {
		
		ServerProtocolInterpreterRunnable server = new ServerProtocolInterpreterRunnable(null);;
		
	
		ServerSocketChannel listenChannel = server.createServerSocketChannel();
		assertNotNull(listenChannel, "Le ServerSocketChannel a été créé" );
		assertNotNull(listenChannel.getLocalAddress(), "Le ServerSocketChannel a été lié");
		final int port = ((InetSocketAddress) listenChannel.getLocalAddress()).getPort();
		
		
		// préparation d'un thread pour se connecter au listenChannel
		FutureTask<SocketChannel> task = new FutureTask<>( new Callable<SocketChannel>() {

			@Override
			public SocketChannel call() throws Exception {
				InetSocketAddress rcvAddress = new InetSocketAddress(InetAddress.getByName("localhost"), port);
				return  SocketChannel.open(rcvAddress);
			}
		}
		);
		
		// lancement du thread qui se connecte au listenChannel
		new Thread(task).start();
		
		SocketChannel connexion = listenChannel.accept();
		assertNotNull(connexion, "L'accept fonctionne");
		
		SocketChannel distant = task.get();
		assertNotNull(distant, "Le distant a réussi sa connexion");
		
	}

}
